using File_Folder_Helper.Models;
using Microsoft.Extensions.Logging;

namespace File_Folder_Helper.Helpers;

internal static class HelperDay
{

    internal static void Select(AppSettings appSettings, ILogger<Worker> logger, List<string> args, CancellationToken cancellationToken)
    {
        logger.LogInformation("X) Day Helpers,");
        if (args[1] == "Day-Helper-2023-09-06")
            Day.Q32023.Helper20230906.SaveJson(logger, args[0]);
        else if (args[1] == "Day-Helper-2023-10-10")
            Day.Q42023.Helper20231010.HgCV(logger, args[0]);
        else if (args[1] == "Day-Helper-2023-10-16")
            Day.Q42023.Helper20231016.MoveDirectory(logger, args[0]);
        else if (args[1] == "Day-Helper-2023-10-24")
            Day.Q42023.Helper20231024.NetUse(logger, args[0]);
        else if (args[1] == "Day-Helper-2023-11-02")
            Day.Q42023.Helper20231102.NuSpec(logger, args[0]);
        else if (args[1] == "Day-Helper-2023-11-08")
            Day.Q42023.Helper20231108.MasterImage(logger, args);
        else if (args[1] == "Day-Helper-2023-11-22")
            Day.Q42023.Helper20231122.ProcessDataStandardFormat(logger, args);
        else if (args[1] == "Day-Helper-2023-11-28")
            logger.LogError("{arg} - has been migrated to File-Watcher", args[1]);
        else if (args[1] == "Day-Helper-2023-11-30")
            Day.Q42023.Helper20231130.RenameReactorProcessDataStandardFormatFiles(logger, args);
        else if (args[1] == "Day-Helper-2023-12-05")
            Day.Q42023.Helper20231205.SplitMarkdownFile(logger, args);
        else if (args[1] == "Day-Helper-2023-12-12")
            logger.LogError("{arg} - was deleted on 2024-04-08", args[1]);
        else if (args[1] == "Day-Helper-2023-12-22")
            Day.Q42023.Helper20231222.ConvertId(logger, args);
        else if (args[1] == "Day-Helper-2024-01-05")
            ADO2024.PI1.Helper20240105.ConvertKeePassExport(logger, args);
        else if (args[1] == "Day-Helper-2024-01-06")
            ADO2024.PI1.Helper20240106.TextToJson(logger, args);
        else if (args[1] == "Day-Helper-2024-01-07")
            ADO2024.PI1.Helper20240107.DirectoryToISO(logger, args);
        else if (args[1] == "Day-Helper-2024-01-08")
            ADO2024.PI1.Helper20240108.SortCodeMethods(logger, args, cancellationToken);
        else if (args[1] == "Day-Helper-2024-01-27")
            logger.LogError("{arg} - has been migrated to Clipboard_Send_Keys", args[1]);
        else if (args[1] == "Day-Helper-2024-01-29")
            ADO2024.PI1.Helper20240129.JsonToTsv(logger, args);
        else if (args[1] == "Day-Helper-2024-03-05")
            ADO2024.PI1.Helper20240305.ArchiveFiles(logger, args);
        else if (args[1] == "Day-Helper-2024-04-03")
            ADO2024.PI1.Helper20240403.AlertIfNewDeviceIsConnected(logger, args);
        else if (args[1] == "Day-Helper-2024-04-04")
            ADO2024.PI1.Helper20240404.ParseCSV(logger, args);
        else if (args[1] == "Day-Helper-2024-04-09")
            ADO2024.PI1.Helper20240409.MonA(logger, args);
        else if (args[1] == "Day-Helper-2024-04-17")
            ADO2024.PI1.Helper20240417.FilteredRunCommand(logger, args, cancellationToken);
        else if (args[1] == "Day-Helper-2024-04-26")
            ADO2024.PI1.Helper20240426.UpdateTests(logger, args);
        else if (args[1] == "Day-Helper-2024-04-27")
            ADO2024.PI1.Helper20240427.Immich(appSettings, logger, args);
        else if (args[1] == "Day-Helper-2024-04-29")
            ADO2024.PI2.Helper20240429.GitConfigCleanUp(logger, args);
        else if (args[1] == "Day-Helper-2024-05-10")
            ADO2024.PI2.Helper20240510.PullIconsForBLM(logger, args);
        else if (args[1] == "Day-Helper-2024-05-13")
            ADO2024.PI2.Helper20240513.PersonKeyToName(logger, args);
        else if (args[1] == "Day-Helper-2024-05-17")
            ADO2024.PI2.Helper20240517.SaveAmazon(logger, args);
        else if (args[1] == "Day-Helper-2024-05-18")
            ADO2024.PI2.Helper20240518.PersonKeyToImmichImport(logger, args);
        else if (args[1] == "Day-Helper-2024-05-19")
            ADO2024.PI2.Helper20240519.FindReplaceDirectoryName(logger, args);
        else if (args[1] == "Day-Helper-2024-05-20")
            ADO2024.PI2.Helper20240520.IdentifierRename(logger, args);
        else if (args[1] == "Day-Helper-2024-06-23")
            ADO2024.PI2.Helper20240623.UpdateSubTasksInMarkdownFiles(logger, args);
        else if (args[1] == "Day-Helper-2024-06-24")
            ADO2024.PI2.Helper20240624.MoveUpOneDirectory(logger, args);
        else if (args[1] == "Day-Helper-2024-07-11")
            ADO2024.PI2.Helper20240711.GitRemoteRemove(logger, args);
        else if (args[1] == "Day-Helper-2024-07-18")
            ADO2024.PI2.Helper20240718.JsonToMarkdown(logger, args);
        else if (args[1] == "Day-Helper-2024-07-28")
            ADO2024.PI2.Helper20240728.DownloadSslCertificates(logger, args);
        else if (args[1] == "Day-Helper-2024-08-05")
            ADO2024.PI3.Helper20240805.RenameFiles(logger, args);
        else if (args[1] == "Day-Helper-2024-08-06")
            ADO2024.PI3.Helper20240806.ArchiveFiles(logger, args);
        else if (args[1] == "Day-Helper-2024-08-09")
            ADO2024.PI3.Helper20240809.CreateWorkItems(logger, args);
        else if (args[1] == "Day-Helper-2024-08-20")
            ADO2024.PI3.Helper20240820.MoveFilesWithSleep(logger, args);
        else if (args[1] == "Day-Helper-2024-08-22")
            ADO2024.PI3.Helper20240822.ParseKanbn(logger, args);
        else if (args[1] == "Day-Helper-2024-08-28")
            ADO2024.PI3.Helper20240828.MoveWaferCounterToArchive(logger, args);
        else if (args[1] == "Day-Helper-2024-08-30")
            ADO2024.PI3.Helper20240830.CompareWorkItems(logger, args);
        else if (args[1] == "Day-Helper-2024-09-10")
            ADO2024.PI3.Helper20240910.MoveFilesToWeekOfYear(logger, args);
        else if (args[1] == "Day-Helper-2024-09-11")
            ADO2024.PI3.Helper20240911.WriteMarkdown(logger, args);
        else if (args[1] == "Day-Helper-2024-09-16")
            ADO2024.PI3.Helper20240916.DebugProxyPass(logger, args);
        else if (args[1] == "Day-Helper-2024-09-25")
            ADO2024.PI3.Helper20240925.DistinctTests(logger, args);
        else if (args[1] == "Day-Helper-2024-10-02")
            ADO2024.PI3.Helper20241002.ConvertInfinityQSProjectFiles(logger, args);
        else if (args[1] == "Day-Helper-2024-10-29")
            ADO2024.PI3.Helper20241029.GetFibonacci(logger, args);
        else if (args[1] == "Day-Helper-2024-10-30")
            ADO2024.PI3.Helper20241030.GetComplete(logger, args);
        else if (args[1] == "Day-Helper-2024-10-31")
            ADO2024.PI3.Helper20241031.GetComplete(logger, args);
        else if (args[1] == "Day-Helper-2024-11-08")
            ADO2024.PI4.Helper20241108.WriteMarkdown(logger, args);
        else if (args[1] == "Day-Helper-2024-11-15")
            ADO2024.PI4.Helper20241115.GetComplete(logger, args);
        else if (args[1] == "Day-Helper-2024-12-04")
            ADO2024.PI4.Helper20241204.ConvertToUTF8(logger, args);
        else if (args[1] == "Day-Helper-2024-12-12")
            ADO2024.PI4.Helper20241212.Rename(logger, args);
        else if (args[1] == "Day-Helper-2024-12-17")
            ADO2024.PI4.Helper20241217.Backup(logger, args);
        else if (args[1] == "Day-Helper-2024-12-24")
            ADO2024.PI4.Helper20241224.Compare(logger, args);
        else if (args[1] == "Day-Helper-2025-01-01")
            ADO2025.PI4.Helper20250101.MoveToDelete(logger, args);
        else if (args[1] == "Day-Helper-2025-01-14")
            ADO2025.PI4.Helper20250114.Rename(logger, args);
        else if (args[1] == "Day-Helper-2025-01-26")
            ADO2025.PI4.Helper20250126.Move(logger, args);
        else if (args[1] == "Day-Helper-2025-02-04")
            ADO2025.PI4.Helper20250204.ExtractKanban(logger, args);
        else if (args[1] == "Day-Helper-2025-02-18")
            ADO2025.PI5.Helper20250218.MoveToArchive(logger, args);
        else if (args[1] == "Day-Helper-2025-02-19")
            ADO2025.PI5.Helper20250219.Compare(logger, args);
        else if (args[1] == "Day-Helper-2025-02-28")
            ADO2025.PI5.Helper20250228.PostgresDumpToJson(logger, args);
        else if (args[1] == "Day-Helper-2025-03-01")
            ADO2025.PI5.Helper20250301.PocketBaseImportWithDeno(logger, args);
        else if (args[1] == "Day-Helper-2025-03-05")
            ADO2025.PI5.Helper20250305.WriteNginxFileSystemDelta(logger, args);
        else if (args[1] == "Day-Helper-2025-03-06")
            ADO2025.PI5.Helper20250306.ProcessDataStandardFormatToJson(logger, args);
        else if (args[1] == "Day-Helper-2025-03-15")
            ADO2025.PI5.Helper20250315.Empty(logger, args);
        else if (args[1] == "Day-Helper-2025-03-20")
            ADO2025.PI5.Helper20250320.SortCodeMethods(logger, args, cancellationToken);
        else if (args[1] == "Day-Helper-2025-03-21")
            ADO2025.PI5.Helper20250321.MoveToLast(logger, args);
        else if (args[1] == "Day-Helper-2025-04-04")
            ADO2025.PI5.Helper20250404.KumaToGatus(logger, args);
        else if (args[1] == "Day-Helper-2025-04-07")
            ADO2025.PI5.Helper20250407.Sync(logger, args);
        else if (args[1] == "Day-Helper-2025-04-21")
            ADO2025.PI5.Helper20250421.FreeFileSyncChangeCreatedDate(logger, args);
        else if (args[1] == "Day-Helper-2025-04-29")
            ADO2025.PI5.Helper20250429.WriteNginxFileSystem(logger, args);
        else if (args[1] == "Day-Helper-2025-05-05")
            ADO2025.PI5.Helper20250505.HyperTextMarkupLanguageToPortableDocumentFormat(logger, args);
        else if (args[1] == "Day-Helper-2025-05-19")
            ADO2025.PI6.Helper20250519.LiveSync(logger, args);
        else if (args[1] == "Day-Helper-2025-05-21")
            ADO2025.PI6.Helper20250521.MatchDirectory(logger, args);
        else if (args[1] == "Day-Helper-2025-06-01")
            ADO2025.PI6.Helper20250601.EquipmentAutomationFrameworkStatus(logger, args);
        else if (args[1] == "Day-Helper-2025-06-02")
            ADO2025.PI6.Helper20250602.EquipmentAutomationFrameworkCellInstanceStateImageVerbIf(logger, args);
        else if (args[1] == "Day-Helper-2025-06-18")
            ADO2025.PI6.Helper20250618.MoveAllButXOfEach(logger, args);
        else if (args[1] == "Day-Helper-2025-06-28")
            ADO2025.PI6.Helper20250628.LogIsoInformation(logger, args);
        else
            throw new Exception(appSettings.Company);
    }

}